#include <math.h>
#define PI 3.141592653589793238462643
/* TEST STATISTICS */
void mdh30w1(double *y, int *n, int *m, double *a, double *g, double *t) 
{
  int it, is, l, k;
  double q, iwx, d, qmax;
  double qs[*n];
  double ct[*n];
  /* scaling by a */
  for(l = 0; l < *n; l++) 
    {
      y[l] = y[l] / *a;
    }
 /* sequential weight */
  for(l = 0; l < (*n - *m - 1); l++) 
    {
      qs[l] = 1.0 / exp ( *g * log( ( 1.0 - ( l + *m + 1.0 ) / *n ) * ( ( l + *m + 1.0 ) / *n  ) ) ) ;
    }
  /* starting value for the maximum, k=n-1*/
  k = *n - 1;
  q = 0.0;
  for(l = 0; l < k; l++) {
    ct[l] = 1.0 - ( 1.0 * k / *n);
  }
  for(l = k; l < *n; l++) {
    ct[l] = 0.0 - ( 1.0 * k / *n);
  }
  /* calculate the sum */
  for(it = *m; it < (*n - 1) ; it++) 
    { 
      q += ct[it] * ct[it] * y[it] * y[it];
      for(is = (it+1); is < *n ; is++)
	{
	  iwx = 1.0;
	  for(l = 1; l < (*m + 1) ; l++)
	    {
	      d = y[it - l] - y[is - l];
	      iwx = iwx / (1.0 + (d * d));
	    }
	  q += 2.0 * ct[it] * ct[is] * y[it] * y[is] * iwx;
	}
    }
  q += y[*n - 1] * y[*n - 1] * ct[*n - 1] * ct[*n - 1];
  qmax = q * qs[k - *m - 1];
  /* calculate the maximum via recursion */
  for (k = *m + 1; k < *n -1 ; k += 1) {
    q = 0.0;
    for(l = 0; l < k ; l++) {
      ct[l] = 1.0 - ( 1.0 * k / *n);
    }
    for(l = k ; l < *n; l++) {
      ct[l] = 0.0 - ( 1.0 * k / *n);
    }
    /* calculate the sum */
    for(it = *m; it < (*n - 1) ; it++) 
      { 
	q += ct[it] * ct[it] * y[it] * y[it];
	for(is = (it+1); is < *n ; is++)
	  {
	    iwx = 1.0;
	    for(l = 1; l < (*m + 1) ; l++)
	      {
		d = y[it - l] - y[is - l];
		iwx = iwx / (1.0 + (d * d));
	      }
	    q += 2.0 * ct[it] * ct[is] * y[it] * y[is] * iwx;
	  }
      }
    q += y[*n - 1] * y[*n - 1] * ct[*n - 1] * ct[*n - 1];
    if (q * qs[k - *m - 1] > qmax) {
      qmax = q * qs[k - *m -1];
    }
  }
  *t = (*a * *a) * (exp( 1.0 * *m * log(2.0 / *a))) * qmax / *n; 
  /* *t = qs[1]; */
}
/* add WILD BOOTSTRAP and P-VALUE*/
void mdh30w1wb(double *y, int *n, int *m, double *a, double *g, int *b, double *eta, double *t) 
{
  int it, is, l, k, ib, count;
  double q, iwx, d, tb, qmax;
  double qs[*n];
  double ct[*n];
  /* scaling by a */
  for(l = 0; l < *n; l++) 
    {
      y[l] = y[l] / *a;
    }
/* sequential weight */
  for(l = 0; l < (*n - *m - 1); l++) 
    {
      qs[l] = 1.0 / exp ( *g * log( ( 1.0 - ( l + *m + 1.0 ) / *n ) * ( ( l + *m + 1.0 ) / *n  ) ) ) ;
    }
  /* starting value for the maximum, k=n-1*/
  k = *n - 1;
  q = 0.0;
  for(l = 0; l < k; l++) {
    ct[l] = 1.0 - ( 1.0 * k / *n);
  }
  for(l = k; l < *n; l++) {
    ct[l] = 0.0 - ( 1.0 * k / *n);
  }
  /* calculate the sum */
  for(it = *m; it < (*n - 1) ; it++) 
    { 
      q += ct[it] * ct[it] * y[it] * y[it];
      for(is = (it+1); is < *n ; is++)
	{
	  iwx = 1.0;
	  for(l = 1; l < (*m + 1) ; l++)
	    {
	      d = y[it - l] - y[is - l];
	      iwx = iwx / (1.0 + (d * d));
	    }
	  q += 2.0 * ct[it] * ct[is] * y[it] * y[is] * iwx;
	}
    }
  q += y[*n - 1] * y[*n - 1] * ct[*n - 1] * ct[*n - 1];
  qmax = q * qs[k - *m - 1];
  /* calculate the maximum via recursion */
  for (k = *m + 1; k < *n -1 ; k += 1) {
    q = 0.0;
    for(l = 0; l < k ; l++) {
      ct[l] = 1.0 - ( 1.0 * k / *n);
    }
    for(l = k ; l < *n; l++) {
      ct[l] = 0.0 - ( 1.0 * k / *n);
    }
    /* calculate the sum */
    for(it = *m; it < (*n - 1) ; it++) 
      { 
	q += ct[it] * ct[it] * y[it] * y[it];
	for(is = (it+1); is < *n ; is++)
	  {
	    iwx = 1.0;
	    for(l = 1; l < (*m + 1) ; l++)
	      {
		d = y[it - l] - y[is - l];
		iwx = iwx / (1.0 + (d * d));
	      }
	    q += 2.0 * ct[it] * ct[is] * y[it] * y[is] * iwx;
	  }
      }
    q += y[*n - 1] * y[*n - 1] * ct[*n - 1] * ct[*n - 1];
    if (q * qs[k - *m - 1] > qmax) {
      qmax = q * qs[k - *m -1];
    }
  }
  t[0] = (*a * *a) * (exp( 1.0 * *m * log(2.0 / *a))) * qmax / *n; 
  /* WILD BOOTSTRAP */
  count=0;
  for (ib = 0; ib < *b; ib++) {
    /* calculate the test stat in wild bootstrap */
    /* starting value for the maximum, k=n-1*/
    k = *n - 1;
    q = 0.0;
    for(l = 0; l < k; l++) {
      ct[l] = 1.0 - ( 1.0 * k / *n);
    }
    for(l = k; l < *n; l++) {
      ct[l] = 0.0 - ( 1.0 * k / *n);
    }
    /* calculate the sum */
    for(it = *m; it < (*n - 1) ; it++) 
      { 
	q += ct[it] * ct[it] * y[it] * y[it] * eta[ib * *n + it] * eta[ib * *n + it];
	for(is = (it+1); is < *n ; is++)
	  {
	    iwx = 1.0;
	    for(l = 1; l < (*m + 1) ; l++)
	      {
		d = y[it - l] - y[is - l];
		iwx = iwx / (1.0 + (d * d));
	      }
	    q += 2.0 * ct[it] * ct[is] * y[it] * y[is] * eta[ib * *n + it] * eta[ib * *n + is] * iwx;
	  }
      }
    q += y[*n - 1] * y[*n - 1] * ct[*n - 1] * ct[*n - 1] * eta[ib * *n + *n - 1] * eta[ib * *n + *n - 1];
    qmax = q * qs[k - *m - 1];
    /* calculate the maximum via recursion */
    for (k = *m + 1; k < *n -1 ; k += 1) {
      q = 0.0;
      for(l = 0; l < k ; l++) {
	ct[l] = 1.0 - ( 1.0 * k / *n);
      }
      for(l = k ; l < *n; l++) {
	ct[l] = 0.0 - ( 1.0 * k / *n);
      }
      /* calculate the sum */
      for(it = *m; it < (*n - 1) ; it++) 
	{ 
	  q += ct[it] * ct[it] * y[it] * y[it] * eta[ib * *n + it] * eta[ib * *n + it];
	  for(is = (it+1); is < *n ; is++)
	    {
	      iwx = 1.0;
	      for(l = 1; l < (*m + 1) ; l++)
		{
		  d = y[it - l] - y[is - l];
		  iwx = iwx / (1.0 + (d * d));
		}
	      q += 2.0 * ct[it] * ct[is] * y[it] * y[is] * eta[ib * *n + it] * eta[ib * *n + is] * iwx;
	    }
	}
      q += y[*n - 1] * y[*n - 1] * ct[*n - 1] * ct[*n - 1] * eta[ib * *n + *n -1] * eta[ib * *n + *n - 1];
      if (q * qs[k - *m - 1] > qmax) {
	qmax = q * qs[k - *m -1];
      }
    }
    /* bootstrap test stat */
    tb = (*a * *a) * (exp( 1.0 * *m * log(2.0 / *a))) * qmax / *n; 
    if (t[0] < tb) {
      count += 1;
    }
  }
  t[1]= 1.0 * count / *b;
}
